// BroadcastSocket.cpp : implementation file
//

#include "stdafx.h"
#include "MUUDPIC.h"
#include "BroadcastSocket.h"
#include "ServerDlg.h"
#include "Client.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBroadcastSocket

CBroadcastSocket::CBroadcastSocket()
{
}

CBroadcastSocket::~CBroadcastSocket()
{
}


// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CBroadcastSocket, CAsyncSocket)
	//{{AFX_MSG_MAP(CBroadcastSocket)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// CBroadcastSocket member functions

void CBroadcastSocket::OnReceive(int nErrorCode) 
{
  ASSERT(m_dlg);
  ASSERT(m_server);

  char buf[512];
  sockaddr_in loc;
  int len = sizeof(loc);
  int rec = ReceiveFrom(buf, 511, (SOCKADDR*)&loc, &len);
  if (rec == SOCKET_ERROR) {
    m_dlg->DisplayLine("Recieve Error!");
    return;
  }

  CClient* cli = m_server->Identify(loc);
  if (cli == NULL) {
    m_dlg->DisplayLine("packet detected from unknown user not signed on!");
    return;
  }

  switch (buf[0]) {
    case HDR_NEW:
      m_dlg->DisplayLine("HDR_NEW is an illegal packet type to be sent to the server!");
      break;
    case HDR_MSG:
      m_server->Talk(cli, &buf[1]);
      break;
    case HDR_EXIT:
      m_server->LeaveClient(cli);
      break;
    case HDR_PING:
      break;
    default: {
      CString temp;
      temp.Format("Unkown packet of type %i detected!", (int)buf[0]);
      m_dlg->DisplayLine(temp);
      temp.Format("Packet was: %s", buf);
      m_dlg->DisplayLine(temp);
      return;
             }
  }

  gin += rec;
  m_dlg->UpdateStats();
}

void CBroadcastSocket::SetDialog(CServerDlg *dlg2, CServer* server)
{
  m_dlg = dlg2;
  m_server = server;
}
