// ServerSocket.cpp : implementation file
//

#include "stdafx.h"
#include "MUUDPIC.h"
#include "ServerSocket.h"
#include "ServerDlg.h"
#include <time.h>
#include <linklist.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CServerSocket

CServerSocket::CServerSocket()
{
}

CServerSocket::~CServerSocket()
{
}


// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CServerSocket, CAsyncSocket)
	//{{AFX_MSG_MAP(CServerSocket)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// CServerSocket member functions

void CServerSocket::OnAccept(int nErrorCode) 
{
  //These MUST have been set before socket creation!
  ASSERT(m_dlg);
  ASSERT(m_server);

  CSocket temp;
  sockaddr_in loc;
  int sizeofloc = sizeof(loc);
  if (!Accept(temp, (SOCKADDR*)&loc, &sizeofloc))
    return;

  CString msg("New Connection Accepted from: ");
  msg += inet_ntoa(loc.sin_addr);
  m_dlg->DisplayLine(msg);

  CClient* newcli = new CClient();
  newcli->loc = loc;

  m_dlg->DisplayLine("Receiving Client Information...");
  char buf[512];
  gin += temp.Receive(buf, 511);

  uchar* buf2 = new uchar;
  m_dlg->DisplayLine("Checking version");
  if (buf[0] == VERSION) {
    *buf2 = GOODVER;
    gout += temp.Send(buf2, 1);
    msg.Format("  Version %i Passed...", int(VERSION));
    m_dlg->DisplayLine(msg);
  } else {
    *buf2 = BADVER;
    gout += temp.Send(buf2, 1);
    msg.Format("  Version %i Failed...  Got Version %i", int(VERSION), int(*buf2));
    m_dlg->DisplayLine(msg);
    temp.Close();
    return;
  }
  delete buf2;                         //Get rid of version temp
  m_dlg->UpdateStats();

  //parse the clients name:
  newcli->name = &buf[1];
  msg = "Welcome ";
  msg += newcli->name;
  m_dlg->DisplayLine(msg);

  //Send the client room info
  // We have to do this before adding the client to the master list because we
  // want to let the client see the server introduce inself, and at that time
  // the client will add itself to the list -- as if it was "another" user,
  // but the human user wouldn't be able to know that!
  m_dlg->DisplayLine("Sending client room information");

  LinkList<CClient>* clients = m_server->GetClients();

  clients->SetToStart();
  int len = clients->Length();
  gout += temp.Send(&len, sizeof(len));                 //Send # of users
  for (int c=0; c<len; c++) {
    int NameLen = strlen(clients->_GetNext()->name) + 1; //to send NULL
    gout += temp.Send(&NameLen, sizeof(NameLen));        //Send name len
    gout += temp.Send(clients->_GetNext()->name, NameLen);//Send name
    gout += temp.Send(&clients->_GetNext()->pingtime, sizeof(int));//pingtime
    clients->_Advance();                                 //Proceed to next cli
    m_dlg->UpdateStats();
  }

  //Ping the client
  unsigned char ping = HDR_PING;
  gout += temp.Send(&ping, sizeof(ping));   //R U red e 2 ping?
  gin += temp.Receive(&ping, sizeof(ping)); //wait for ACK
  gout += temp.Send(&ping, sizeof(ping));   //Send real ping req
  int start = clock();
  gin += temp.Receive(&ping, sizeof(ping)); //get ACK
  int end = clock();
  newcli->pingtime = (end - start) * 1000 / CLOCKS_PER_SEC;
  gout += temp.Send(&newcli->pingtime, sizeof(newcli->pingtime));
    //Report back to client
  msg.Format("client got ping time of %i ms", newcli->pingtime);
  m_dlg->DisplayLine(msg);
  m_dlg->UpdateStats();

  //Get clients UDP port contact information
  m_dlg->DisplayLine("Moving client to UDP port");
  gin += temp.Receive(&newcli->loc.sin_port, sizeof(newcli->loc.sin_port));
  m_dlg->UpdateStats();
  temp.Close();

  //add the client to the list
  m_server->AddClient(newcli);
}

void CServerSocket::SetDialog(CServerDlg* dlg2, CServer* server)
{
  m_dlg = dlg2;
  m_server = server;
}
